#include <sptk3/cutils>
#include <sptk3/CSmtpConnect.h>
#include <iostream>

using namespace std;
using namespace sptk;

int main (int argc, const char* argv[])
{
    CSmtpConnect    smtp;
    CRegistry       settings ("smtp_connect.xml", "sptk_test", USER_REGISTRY);

#if HAVE_GNUTLS
    CSocket::globalInitTLS();
#endif

    try {
        settings.load();
        CXmlNode* smtpNode = settings.findFirst ("smtp");
        CXmlNode* testNode = settings.findFirst ("test");
        if (!smtpNode || !testNode) {
            if (!smtpNode) {
                smtpNode = new CXmlElement (settings, "smtp");
                smtpNode->setAttribute ("user", "John");
                smtpNode->setAttribute ("password", "secret");
                smtpNode->setAttribute ("host", "localhost");
                smtpNode->setAttribute ("port", "25");
            }
            if (!testNode) {
                testNode = new CXmlElement (settings, "test");
                testNode->setAttribute ("from", "root@localhost");
                testNode->setAttribute ("to", "root@localhost");
            }
            settings.save();
            cerr << "Please edit ~/.sptk_test/smtp_connect.xml file for your SMTP user name and password" << endl;
            return 1;
        }

        string host = smtpNode->getAttribute("host");
        int    port = smtpNode->getAttribute("port");
        string user = smtpNode->getAttribute("user");
        string pass = smtpNode->getAttribute("password");

        string from = testNode->getAttribute("from");
        string to   = testNode->getAttribute("to");

        smtp.host(host);
        smtp.port(port);

        smtp.from(from);
        smtp.to(to);
        smtp.subject("test");
        smtp.body("<html><b>This</b> is a test",false);
        smtp.attachments("/svn/sptk3/trunk/examples/net/smtp_connect.cpp");

        smtp.cmd_login(user, pass, false);
        smtp.cmd_send();
        smtp.close();

    } catch (exception& e) {
        cerr << e.what() << endl;
        return 1;
    }

    return 0;
}
