/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CMailMessageBody.cpp  -  description
                             -------------------
    begin                : 25 Oct 2004
    copyright            : (C) 2000-2008 by Alexey Parshin. All rights reserved.
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
  * Neither the name of the <ORGANIZATION> nor the names of its contributors
    may be used to endorse or promote products derived from this software
    without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#include <sptk3/CMailMessageBody.h>
#include <sptk3/CStrings.h>
#include <sptk3/istring.h>
#include <sptk3/string_ext.h>
#include <string.h>

#include <vector>
#include <map>

using namespace std;
using namespace sptk;

string CMailMessageBody::stripHtml(const string& origHtml) {
   CStrings html(origHtml,"<");
   unsigned    i = 0;

   // Remove comments and scripts
   for (i = 0; i < html.size(); i++) {
       string& str = html[i];
       size_t pos = str.find(">");
       if (pos == string::npos)
           continue;
       str = str.substr(pos+1);
       if (str.empty()) {
           html.erase(html.begin()+i);
           i--;
       }
   }

   return trim(replaceAll(replaceAll(html.asString(" "),"   "," "),"  "," "));
}

void CMailMessageBody::text(const string& messageText,bool smtp) {
   string msg;
   if (smtp)
      msg = replaceAll(messageText,"\n.\n","\n \n");
   else
      msg = messageText;
   if (upperCase(messageText.substr(0,100)).find("<HTML>") == string::npos) {
      m_type = MMT_PLAIN_TEXT_MESSAGE;
      m_plainText = msg;
      m_htmlText = "";
   } else {
      m_type = MMT_HTML_MESSAGE;
      m_plainText = stripHtml(msg);
      m_htmlText = msg;
   }
}
